require 'hashie'

module ASM
  class Config
    def initialize(config_file = nil)
      config_file ||= ENV["ASM_CONFIG"] ||
          File::join(File::dirname(__FILE__), '..', '..', 'config.yaml')
      yaml = YAML.load_file(config_file)
      @mash = Hashie::Mash.new(yaml)

      [:large_process_concurrency, :large_process_max_runtime,
       :metrics_poller_concurrency, :metrics_poller_timeout].each do |key|
        # These are expected to be integers, but allow code to be specified as a string
        if @mash[key].is_a?(String)
          @mash[key] = eval(@mash[key])
        end
      end
    end

    # Forward methods we don't define directly to the mash
    def method_missing(sym, *args, &block)
      @mash.send(sym, *args, &block)
    end

  end
end