require 'json'
require 'asm'
require 'pp'

module ASM
  class Monitoring
    def conf
      @config ||= database_config(ASM::Util::DATABASE_CONF)
    end

    def inventory_db
      @inventory_db ||= connect_db("asm_manager")
    end

    def credentials_db
      @credentials_db ||= connect_db("encryptionmgr")
    end

    def connect_db(db_name)
      if RUBY_PLATFORM == 'java'
        require 'jdbc/postgres'
        Jdbc::Postgres.load_driver
        Sequel.connect("jdbc:postgresql://#{conf.host}/#{db_name}?user=#{conf.username}&password=#{conf.password}")
      else
        require 'pg'
        Sequel.connect("postgres://#{conf.username}:#{conf.password}@#{conf.host}:#{conf.port}/#{db_name}")
      end
    end

    def update_service_status(state)
      inventory_db.from(:device_inventory).where('ref_id = ?', state["host"]).update(:health => state["state"], :health_message => state["service"])
    end
  end
end
